import fisica.*;
FWorld world;
PVector clickPos;
color[] colors = {#FE0000, #FF4001, #FFC926, #248C01, 
  #037DFA, #A300DA, #FF4DFF, #FFFFFF, #000000};
color currentColor = #FFFFFF;
PImage[] buttons = new PImage[9];
PImage back, ball;

void setup() {
  size(900, 600);
  back = loadImage("back.png");
  ball = loadImage("ball.png");
  for (int i = 0; i < 9; i++) {
    buttons[i] = loadImage("color"+i+".png");
  }
  noStroke();
  Fisica.init(this);
  world = new FWorld();
}

void draw() {
  image(back, 0, 0);
  for (int i = 0; i < 9; i++) {
    image(buttons[i], i*100, 0);
  }

  if (frameCount % 100 == 0) {
    FCircle b = new FCircle(25);
    b.setPosition(random(width), 0);
    b.setNoStroke();
    b.attachImage(ball);
    world.add(b);
  }

  if (clickPos != null) {
    fill(currentColor);
    rect(clickPos.x, clickPos.y, mouseX - clickPos.x, mouseY - clickPos.y);
  }
  
  world.step();
  world.draw();
}

void mousePressed() {
  if (mouseY < 70) {
    currentColor = colors[(int)mouseX/100];
  } else {
    clickPos = new PVector(mouseX, mouseY);
  }
}

void mouseReleased() {
  clickPos = null;
}
