import fisica.*;
FWorld world;
PVector clickPos;
color[] colors = {#FE0000, #FF4001, #FFC926, #248C01, 
  #037DFA, #A300DA, #FF4DFF, #FFFFFF, #000000};
color currentColor = #FFFFFF;
PImage[] buttons = new PImage[9];
PImage back, ball;

void setup() {
  size(900, 600);
  back = loadImage("back.png");
  ball = loadImage("ball.png");
  for (int i = 0; i < 9; i++) {
    buttons[i] = loadImage("color"+i+".png");
  }
  noStroke();
  Fisica.init(this);
  world = new FWorld();
}

void draw() {
  image(back, 0, 0);
  for (int i = 0; i < 9; i++) {
    image(buttons[i], i*100, 0);
  }

  if (frameCount % 100 == 0) {
    FCircle b = new FCircle(25);
    b.setPosition(random(width), 0);
    b.setNoStroke();
    b.attachImage(ball);
    world.add(b);
  }

  if (clickPos != null) {
    fill(currentColor);
    rect(clickPos.x, clickPos.y, mouseX - clickPos.x, mouseY - clickPos.y);
  }
  
  world.step();
  world.draw();
}

void mousePressed() {
  if (mouseY < 70) {
    currentColor = colors[(int)mouseX/100];
  } else {
    clickPos = new PVector(mouseX, mouseY);
  }
}

void mouseReleased() {
  float w = 0, h = 0, cx = 0, cy = 0;
  if (clickPos != null) {
    w = abs(clickPos.x - mouseX);
    h = abs(clickPos.y - mouseY);
    cx = min(clickPos.x, mouseX) + w / 2;
    cy = min(clickPos.y, mouseY) + h / 2;
  }
  clickPos= null;
  if (w < 5 || h < 5) {
    return;
  }
  
  if (mouseButton == RIGHT) {
    FCircle c = new FCircle(w);
    c.setFillColor(currentColor);
    c.setPosition(cx, cy);
    c.setNoStroke();
    c.setStatic(true);
    world.add(c);
  } 
  else if (mouseButton == LEFT) {
    FBox roter = new FBox(w, h);
    roter.setPosition(cx, cy);
    roter.setFillColor(currentColor);
    roter.setNoStroke();
    FCircle pivot = new FCircle(20);
    pivot.setPosition(cx, cy);
    pivot.setStatic(true);
    FRevoluteJoint joint = new FRevoluteJoint(roter, pivot);
    world.add(pivot);
    world.add(roter);
    world.add(joint);
  }
}
