import fisica.*;
FWorld world;
PImage ball;
float power = 0;

void setup() {
  size(600, 800);
  ball = loadImage("ball.png");
  Fisica.init(this);
  world = new FWorld();
  world.setEdges();
  world.remove(world.bottom);
  strokeWeight(10);
  for (int y = 0; y < 7; y++) {
    for (int x = 0; x < 7; x++) {
      float xpos = x*70+15+30*(y%2);
      float ypos = y*70+120;
      if (dist(270, 400, xpos, ypos) < 130) {
        continue;
      }
      createCircle(5, xpos, ypos, true);
    }
  }
  createBox(10, 600, 540, 500, 0, true);
  createBox(180, 5, 90, 650, 0.3, true);
  createBox(180, 5, 440, 650, -0.3, true);
  createBox(200, 10, 510, 70, 0.6, true);
}

void draw() {
  background(255);
  if (mousePressed) {
    power = min(power + 1, 190);
  }
  world.step();
  world.draw();
  stroke(0, 255, 255, 80);
  line(0, 790, power*3, 790);
}

void mouseReleased() {
  FCircle c = createCircle(30, 575, 750, false);
  c.addForce(0, -power*1000);
  c.attachImage(ball);
  power = 0;
}

FCircle createCircle(float size, float x, float y, boolean isStatic) {
  FCircle c = new FCircle(size);
  c.setPosition(x, y);
  c.setStatic(isStatic);
  world.add(c);
  return c;
}

FBox createBox(float w, float h, float x, float y, float r, boolean isStatic) {
  FBox b = new FBox(w, h);
  b.setPosition(x, y);
  b.setRotation(r);
  b.setStatic(isStatic);
  world.add(b);
  return b;
}
