float theta = 0;
PVector[] snows = new PVector[100];

void setup() {
  size(600, 600, P3D);
  noStroke();
  for (int i = 0; i < snows.length; i++) {
    snows[i] = new PVector(
      random(-600, 600), 
      random(-600, 600), 
      random(-600, 600)
      );
  }
}

void draw() {
  background(0);
  fill(255);
  directionalLight(255, 255, 255, 0, 0, -1);
  ambientLight(51, 102, 126);

  translate(width/2, height/2);
  drawSnowMan();
  drawSnowFlake();
}

void drawSnowFlake() {
  fill(255);
  for (int i = 0; i < snows.length; i++) {
    PVector p = snows[i];
    pushMatrix();
    translate(p.x, p.y, p.z);
    sphere(5);
    popMatrix();
    p.y += 1;
    if (p.y > height) {
      p.y = -height;
    }
  }
}

void drawSnowMan() {
  pushMatrix();
  theta += 0.02;
  rotateY(theta);
  sphere(100);
  translate(0, -150);
  sphere(80);
  translate(0, 300);
  fill(0, 0, 255);
  box(120);
  translate(30, -300, 70);
  fill(0);
  sphere(10);
  translate(-60, 0, 0);
  sphere(10);
  popMatrix();
}
