PShape earth, moon;
float earthRotation = 0;
float moonRevolution = 0;

void setup(){
  size(600, 600, P3D);
  earth = createShape(SPHERE, 100);
  earth.setTexture(loadImage("earth.jpg"));
  earth.setStroke(false);

  moon = createShape(SPHERE, 30);
  moon.setTexture(loadImage("moon.jpg"));
  moon.setStroke(false);
}

void draw(){
  background(0);
  directionalLight(255,255,255, 1, 0, 0);
  ambientLight(50,50,50);
  translate(width/2, height/2);
  earthRotation += 0.01;
  moonRevolution += 0.005;
  drawEarth();
  drawMoon();
}

void drawEarth(){
  pushMatrix();
  rotateY(earthRotation);
  shape(earth);
  popMatrix();
}

void drawMoon(){
  pushMatrix();
  float x = 200 * cos(moonRevolution);
  float z = 200 * sin(moonRevolution);
  translate(x, 0, z);
  shape(moon);
  popMatrix();
}
