PShape earth, moon, sun;
float sunRotation = 0;
float earthRotation = 0, earthRevolution = 0;
float moonRevolution = 0;

void setup(){
  size(600, 600, P3D);
  earth = createShape(SPHERE, 20);
  earth.setTexture(loadImage("earth.jpg"));
  earth.setStroke(false);

  moon = createShape(SPHERE, 10);
  moon.setTexture(loadImage("moon.jpg"));
  moon.setStroke(false);

  sun = createShape(SPHERE, 60);
  sun.setTexture(loadImage("sun.jpg"));
  sun.setStroke(false);
}

void draw(){
  background(0);
  ambientLight(150,150,150);
  translate(width/2, height/2);
  drawSun();
}

void drawSun(){
  pushMatrix();  
  sunRotation += 0.005;
  float x = 250 * cos(earthRevolution);
  float z = 250 * sin(earthRevolution);  
  spotLight(255,255,255, 0,0,0, x,0,z, radians(50), 30);
  drawEarth(x, z);
  rotateY(sunRotation);
  shape(sun);
  popMatrix(); 
}

void drawEarth(float x, float z){
  pushMatrix();
  earthRotation += 0.01;
  earthRevolution += 0.005;  
  translate(x, 0, z);
  drawMoon();
  rotateY(earthRotation);
  shape(earth);
  popMatrix();
}

void drawMoon(){
  pushMatrix();
  moonRevolution += 0.05;  
  float x = 30 * cos(moonRevolution);
  float z = 30 * sin(moonRevolution);
  translate(x, 0, z);
  shape(moon);
  popMatrix();
}
