float theta = 0, area = 2000;
PVector pos, speed;
ArrayList<PVector> cubes = new ArrayList<PVector>();
void setup() {
  size(600, 600, P3D);
  pos = new PVector(0, 0, 0);
  speed = new PVector(0, 0, 0);
  for(int i = 0 ; i < 50 ; i++){
    cubes.add(
      new PVector(random(-area, area), 0, random(-area,area)));
  }
  textSize(50);
  textAlign(CENTER);
}

void updateCamera() {
  float x = pos.x + 500 * cos(theta);
  float z = pos.z + 500 * sin(theta);
  camera(pos.x, -100, pos.z, x, 0, z, 0, 1, 0);  
}

void draw() {
  background(0);
  
  if (keyPressed) {
    if (keyCode == LEFT) {
      theta -= 0.05;
    }
    if (keyCode == RIGHT) {
      theta += 0.05;
    }
    if (keyCode == UP) {
      speed.x += cos(theta)*2;
      speed.z += sin(theta)*2;
    }
    if (keyCode == DOWN) {
      speed.x -= cos(theta);
      speed.z -= sin(theta);
    }
  }
  speed.mult(0.95);
  pos.x = max(-area, min(area, pos.x + speed.x));
  pos.z = max(-area, min(area, pos.z + speed.z));
  
  updateCamera();
  lights();
  fill(125);
  box(area*2, 10, area*2);

  fill(255);
  for(int i = 0 ; i < cubes.size() ; i++){
    PVector p = cubes.get(i);
    drawCube(p);
  }
}

void drawCube(PVector p) {
  pushMatrix();
  translate(p.x, 0, p.z);
  box(50);
  popMatrix();
}
