float theta = 0, area = 2000;
PVector pos, speed;
ArrayList<PVector> cubes = new ArrayList<PVector>();

void setup() {
  size(600, 600, P3D);
  pos = new PVector(0, 0, 0);
  speed = new PVector(0, 0, 0);
  for (int i = 0; i < 50; i++) {
    cubes.add(
      new PVector(random(-area, area), 0, random(-area, area)));
  }
  textSize(50);
  textAlign(CENTER);
}

void updateCamera() {
  float x = pos.x + 500 * cos(theta);
  float z = pos.z + 500 * sin(theta);
  camera(pos.x, -100, pos.z, x, 0, z, 0, 1, 0);
}

void draw() {
  if (width-frameCount/2 < 0) {
    text("GAME OVER", 300, 300);
    return;
  }
  background(0);
  pushMatrix();
  if (keyPressed) {
    if (keyCode == LEFT) {
      speed.y -= 0.01;
    }
    if (keyCode == RIGHT) {
      speed.y += 0.01;
    }
    if (keyCode == UP) {
      speed.x += cos(theta)*2;
      speed.z += sin(theta)*2;
    }
    if (keyCode == DOWN) {
      speed.x -= cos(theta);
      speed.z -= sin(theta);
    }
  }
  speed.mult(0.95);
  pos.x = max(-area, min(area, pos.x + speed.x));
  pos.z = max(-area, min(area, pos.z + speed.z));
  theta += speed.y;

  lights();
  updateCamera();

  fill(200);
  box(area*2, 10, area*2);

  fill(255);
  int remove = -1;
  for (int i = 0; i < cubes.size(); i++) {
    PVector p = cubes.get(i);
    drawCube(p);
    float d = dist(p.x, p.z, pos.x, pos.z);
    if (d < 150) {
      remove = i; 
      break;
    }
  }
  if (remove >= 0) {
    cubes.remove(remove);
  }
  popMatrix();
  fill(255, 255, 0);
  rect(0, 0, width-frameCount/2, 20);
  text("score" + (50 - cubes.size()), 300, 100);
}

void drawCube(PVector p) {
  pushMatrix();
  translate(p.x, 0, p.z);
  box(50);
  popMatrix();
}
