int[][] maze = new int[21][21];
PVector pos = new PVector(0, 0, 0);

void setup() {
  size(600, 600, P3D);
  createMaze();
}

void draw() {
  background(0);
  float tx = cos(radians(pos.y)) * 500 + pos.x;
  float tz = sin(radians(pos.y)) * 500 + pos.z;
  camera(pos.x, -100, pos.z, tx, 0, tz, 0, 1, 0);
  
  for (int z = 0; z < 21; z++) {
    for (int x = 0; x < 21; x++) {
      if (maze[z][x] == 1) {
        putBox(x*20, 0, z*20, 20, 20, 20);
      }
    }
  }
}

void putBox(int x, int y, int z, int w, int h, int d) {
  pushMatrix();
  translate(x, y, z);
  box(w, h, d);
  popMatrix();
}


void createMaze() {
  for (int i = 0; i < 21; i++) {
    maze[i][0] = maze[i][20] = maze[0][i] = maze[20][i] = 1;
  }
  for (int z = 2; z < 20; z+=2) {
    for (int x = 2; x < 20; x+=2) {
      maze[z][x] = 1;
      while (true) {
        int d = (int)random(z == 2 ? 4 : 3);
        int dx = 0, dy = 0;
        switch(d) {
        case 0: 
          dx = -1; 
          break;  // left
        case 1: 
          dx = 1; 
          break;   // right
        case 2: 
          dy = 1;  
          break;  // down  
        case 3: 
          dy = -1; 
          break;  // up
        }
        if (maze[z+dy][x+dx] == 0) {
          maze[z+dy][x+dx] = 1;
          break;
        }
      }
    }
  }
}

void keyPressed(){
  float nx = cos(radians(pos.y))*20;
  float nz = sin(radians(pos.y))*20;
  if (keyCode == RIGHT) {
    pos.y += 10;
  }
  if (keyCode == LEFT) {
    pos.y -= 10;
  }  
  if (keyCode == UP) {
    pos.x += nx;
    pos.z += nz;
  }
  if (keyCode == DOWN) {
    pos.x -= nx;
    pos.z -= nz;
  }   
}
