import fisica.*;
FWorld world;
void setup() {
  size(750, 750, P3D);
  Fisica.init(this);
  world = new FWorld(); 
  world.setGrabbable(false);    
  createMaze();
  noStroke();
}

void draw() {
  background(0);
  world.step();
  world.draw();
}

void createMaze() {
  for (int i = 0; i < 15; i++) {
    createBox(i, 0);
    createBox(i, 14);
    createBox(0, i);
    createBox(14, i);
  }
  for (int y = 2; y < 14; y+=2) {
    for (int x = 2; x < 14; x+=2) {
      createBox(x, y);
      int d = (int)random(y == 2 ? 4 : 3);
      int dx = 0, dy = 0;
      switch(d) {
      case 0:  // left 
        dx = -1; 
        break;
      case 1:  // right
        dx = 1; 
        break;
      case 2:  // down  
        dy = 1;  
        break; 
      case 3:  // up 
        dy = -1; 
        break;
      }
      createBox(x+dx, y+dy);
    }
  }
}

void createBox(int x, int y) {
  FBox box = new FBox(50, 50);   
  box.setPosition(x*50, y*50);
  box.setStatic(true);
  world.add(box);
}
