class Quiz {
  PImage picL, picR;
  PVector[] points = new PVector[5];
  boolean[] founds = new boolean[5];

  Quiz(int index){
    picL = loadImage("pic" + index + "-L.png");
    picR = loadImage("pic" + index + "-R.png");
  }
  
  void setPos(int[] p){
    for(int i = 0 ; i < 5 ; i++){
      points[i] = new PVector(p[i*2], p[i*2+1]);
    }
  }
}

int index = 0;
Quiz[] quiz = new Quiz[3];

void setup() {
  size(1200, 450);
  for(int i = 0 ; i < 3 ; i++){
    quiz[i] = new Quiz(i);
  }
  quiz[0].setPos(new int[]{
    144, 33, 350, 155, 140, 272, 278, 274, 113, 400
  });
  quiz[1].setPos(new int[]{
    225, 265, 50, 345, 25, 160, 433, 105, 182, 65, 
  });
  quiz[2].setPos(new int[]{
    225, 67, 467, 147,  166, 313, 18, 258, 134, 400
  });

  noFill();
  strokeWeight(5);
  stroke(255, 255, 0);
}

void draw() {
  background(255);
  Quiz p = quiz[index];
  image(p.picL, 0, 0);
  image(p.picR, 600, 0);
  for (int i = 0; i < 5; i++) {
    if (p.founds[i]) {
      ellipse(p.points[i].x, p.points[i].y, 50, 50);
    }
  }
}

void mousePressed() {
  Quiz p = quiz[index];

  boolean clear = p.founds[0] && p.founds[1] && p.founds[2]
       && p.founds[3] && p.founds[4];
  if (clear) {
    p.founds = new boolean[]{false, false, false, false, false};
    index = (index + 1) % 3;
  }  

  for (int i = 0; i < 5; i++) {
    float d = dist(mouseX, mouseY, p.points[i].x, p.points[i].y);
    if (d < 30) {
      p.founds[i] = true;
    }
  }
}
