float posy = 300, speedy = 0, energy = 0, scroll = 0;
PImage[] sticks = new PImage[8];
PImage building, back;
int index = 0;
boolean gameOver;
ArrayList<Box> boxes = new ArrayList<Box>();

class Box {
  float x, y, w, h;
  Box(float x, float y) {
    this.x = x;
    this.y = y;
    this.w = random(100, 300);
    this.h = 500;
  }
  boolean isLanded(float px, float py) {
    return (x < px && px < x+w && y < py && py < y + 30);
  }
}

void addNewBox() {
  float edge = 0;
  int i = boxes.size();
  if (i > 0) {
    Box b = boxes.get(i-1);
    edge = b.x + b.w;
  }
  boxes.add( new Box(edge + random(100, 300), random(300, 480)) );
}

void setup() {
  size(600, 600);
  for (int i = 0; i < 8; i++) {
    sticks[i] = loadImage("stick" + i + ".png");
  }
  building = loadImage("building.png"); 
  back = loadImage("back.png");
  boxes.add(new Box(50, 400));
  for (int i = 0; i < 3; i++) {
    addNewBox();
  }
  textSize(50);
  textAlign(CENTER);
}

void draw() {
  clip(0, 0, width, height);
  image(back, scroll, 0);

  fill(0, 255, 255);
  rect(0, 0, energy, 10);
  
  for (Box b : boxes) {
    image(building, b.x, b.y, b.w, b.h);
  }
  
  fill(255, 255, 0);
  text((int)abs(scroll)+"m", 450, 60);
  if (gameOver) {
    text("GAME OVER", width/2, height/2);
    return;
  }
  
  image(sticks[index], 100, posy, 75, 100);

  posy += speedy;
  speedy += 0.2;
  if (posy > height) {
    gameOver = true;
  }

  boolean landed = false;
  for (Box b : boxes) {
    landed = b.isLanded(140, posy+100+speedy);
    if (landed) {
      break;
    }
  }

  if (landed) {
    speedy = 0;
  } else {
    index = (index + 1) % 8;
    Box r = null;    
    for (Box b : boxes) {
      b.x -= 5;
      if (b.x + b.w < 0) {
        r = b;
        break;
      }
    }
    if (r != null) {
      boxes.remove(r);
      addNewBox();
    }
    scroll -= 1;
    if (scroll < -1065) {
      scroll = 0;
    }
  }

  if (mousePressed) {
    energy = min(600, energy + 5);
  }
}

void mouseReleased() {
  if (energy > 0) {
    speedy = -energy / 40;
    energy = 0;
  }
}
