void setup() {
  size(600, 600);
}

void draw() {
  background(0);
  stroke(255);
  translate(300, 300);
  for (int i = 0; i < 60; i++) {
    if (i % 5 == 0) {
      strokeWeight(5);
    } else {
      strokeWeight(1);
    }
    line(0, -270, 0, -290);
    rotate(radians(6));
  }

  int h = hour();    // Values from 0 - 23
  int m = minute();  // Values from 0 - 59
  int s = second();  // Values from 0 – 59
  float ht = 30 * h + 0.5 * m;
  float mt = 6 * m;
  float st = 6 * s;
  draw_hand(ht, #ff0000, 200, 4);
  draw_hand(mt, #00ff00, 250, 3);
  draw_hand(st, #0000ff, 280, 2);
}

void draw_hand(float d, color c, float s, float w) {
  stroke(c);
  strokeWeight(w);
  rotate(radians(d));
  line(0,0, 0, -s);
  rotate(radians(-d));
}
