void setup() {
  size(600, 600);
  frameRate(30);
}

void draw() {
  fill(0, 0, 0, 30);
  rect(0, 0, width, height);
  translate(300, 300);

  stroke(255);
  noFill();
  for (int i = 0; i < 12; i++) {
    line(0, -280, 0, -290);
    rotate(radians(30));
  }

  int f = frameCount % 30;
  int h = hour();    // Values from 0 - 23
  int m = minute();  // Values from 0 - 59
  int s = second();  // Values from 0 – 59
  float ht = (h % 12) * 30 + 0.5 * m;
  float mt = 6 * m;
  float st = 6 * s;
  noStroke();
  draw_ball(ht * f / 30, #ff00cc, 200, 4);
  draw_ball(mt * f / 30, #ccff00, 230, 3);
  draw_ball(st * f / 30, #0000ff, 260, 2);
}

void draw_ball(float d, color c, float s, float w) {
  fill(c);
  rotate(radians(d));
  ellipse(0, -s, 20, 20);
  rotate(radians(-d));
}
