import fisica.*;

FWorld world;
FBox fixBox;
FPoly fixPoly;

void setup() {
  size(400, 400);
  Fisica.init(this);
  world = new FWorld();
  world.setEdges();
  world.remove(world.left);
  world.remove(world.right);
  
  fixBox = new FBox(100, 40);
  fixBox.setPosition(100, 200);
  fixBox.setStatic(true);
  fixBox.setFillColor(#6E0595);
  world.add(fixBox);
  
  fixPoly = new FPoly();
  fixPoly.vertex(40, 20);
  fixPoly.vertex(-40, 20);
  fixPoly.vertex(0, -20);
  fixPoly.setPosition(300, 300);
  fixPoly.setStatic(true);
  fixPoly.setFillColor(#6E0595);
  world.add(fixPoly);
}

void draw(){
  fixBox.setRotation(radians(frameCount));
  fixPoly.setRotation(radians(frameCount*-2));
  background(255);
  world.step();
  world.draw();
}

void mousePressed(){
  FCircle b = new FCircle(25);
  b.setPosition(mouseX, mouseY);
  b.setRestitution(0.5);
  b.setNoStroke();
  b.setFill(255, 80, 120);
  world.add(b);
}
