import fisica.*;
FWorld world;
PImage apple;

void setup() {
  size(600, 600);
  apple = loadImage("apple.png");
  Fisica.init(this);
  world = new FWorld();
  FBox box = new FBox(600, 20);
  box.setPosition(300, 400);
  box.setStatic(true);
  box.setRotation(0.15);
  world.add(box);
}

void draw() {
  background(255);
  if (frameCount % 200 == 0) {
    add_apple();
  }
  draw_apple();  
  world.step();
  world.draw();
}

void draw_apple() {
  ArrayList bodies = world.getBodies();
  for (int i = 0; i < bodies.size(); i++) {
    FBody body = (FBody)bodies.get(i);
    image(apple, body.getX(), body.getY());
  }
}

void add_apple() {
  FCircle c = new FCircle(40);
  c.setPosition(random(width), 0);
  c.setFill(255, 0, 0, 120);
  c.setNoStroke();
  world.add(c);
}
