import fisica.*;
FWorld world;
PImage apple, orange;

void setup() {
  size(600, 600);
  apple = loadImage("apple.png");
  orange = loadImage("orange.png");
  imageMode(CENTER);

  Fisica.init(this);
  world = new FWorld();
  FBox box = new FBox(600, 20);
  box.setPosition(300, 400);
  box.setStatic(true);
  box.setRotation(0.15);
  world.add(box);
}

void draw() {
  background(255);
  if (frameCount % 100 == 0) {
    add_fruit("apple");
    add_fruit("orange");
  }
  draw_fruit();  
  world.step();
  world.draw();
}

void draw_fruit() {
  ArrayList<FBody> bodies = world.getBodies();
  for (int i = 0; i < bodies.size(); i++) {
    FBody body = bodies.get(i);
    if (body instanceof FCircle){
      FCircle c = (FCircle)body;
      float s = c.getSize();
      PImage fruit = apple;
      if (c.getName() == "orange"){
        fruit = orange;
      }
      draw_rotate(fruit, body.getX(), body.getY(),
                  s, s, c.getRotation());
    }
    //body.drawDebug(this);
  }
}

void draw_rotate(PImage img, float x, float y, 
                      float w, float h, float r){
  pushMatrix();
  translate(x, y);
  rotate(r);
  image(img, 0, 0, w, h);
  popMatrix();
}

void add_fruit(String name) {
  FCircle c = new FCircle(40);
  c.setName(name);
  c.setPosition(random(width), 0);
  c.setFill(255, 0, 0, 120);
  c.setNoStroke();
  world.add(c);
}
