import fisica.*;
FWorld world;
PImage apple, orange, back;

void setup() {
  size(600, 600);
  back = loadImage("back.png");
  apple = loadImage("apple-s.png");
  orange = loadImage("orange-s.png");
  imageMode(CENTER);
    
  Fisica.init(this);
  world = new FWorld();
  FBox box = new FBox(600, 20);
  box.setPosition(300, 400);
  box.setStatic(true);
  box.setRotation(0.15);
  world.add(box);
}

void draw() {
  imageMode(CORNER);
  image(back, 0, 0);
  imageMode(CENTER);
  if (frameCount % 100 == 0) {
    add_fruit("apple");
    add_fruit("orange");
  }
  draw_apple();
  world.step();
}

void draw_apple() {
  ArrayList<FBody> bodies = world.getBodies();
  for (int i = 0; i < bodies.size(); i++) {
    FBody body = bodies.get(i);
    if (body instanceof FCircle){
      FCircle c = (FCircle)body;
      float s = c.getSize();
      PImage img = apple;
      if (c.getName() == "orange"){
        img = orange;
      }
      draw_rotate(img, body.getX(), body.getY(), 
                  s, s, body.getRotation());
    }
  }
}

void draw_rotate(PImage img, float x, float y,
                 float w, float h, float r){
  pushMatrix();
  translate(x, y);
  rotate(r);
  image(img, 0, 0, w, h);
  popMatrix();
}

void add_fruit(String name) {
  FCircle c = new FCircle(40);
  c.setName(name);
  c.setPosition(random(width), 0);
  world.add(c);
}
