import fisica.*;
FWorld world;
FBox car;
PImage back;
boolean goal = false;
int elapsed = 0;

void setup() {
  size(800, 800);
  Fisica.init(this);
  back = loadImage("back.jpg");
  world = new FWorld();
  world.setEdges();
  world.setGravity(0, 0);
  car = createBox(100, 100, 100, 50, loadImage("car.png"), false);
  PImage tile = loadImage("tile.png"); 
  for (int i = 0; i < 12; i++) {
    createBox(i*50, 200, 50, 50, tile, true);
    createBox(i*50+200, 400, 50, 50, tile, true);
    createBox(i*50, 600, 50, 50, tile, true);
  }
  textAlign(CENTER);
  textSize(50);
}

void draw() {
  image(back, 0, 0);
  world.step();
  world.draw(); 
  text("time:"+elapsed, 600, 50);
  if (goal) {
    text("GOAL!!", 400, 400);
    return;
  }
  elapsed = frameCount;  
  if (keyPressed) {
    if (keyCode == UP) {
      float r = car.getRotation();
      float fx = cos(r)*10000;  
      float fy = sin(r)*10000;
      car.addForce(fx, fy);
    }
    if (keyCode == RIGHT) {
      car.addTorque(100);
    }
    if (keyCode == LEFT) {
      car.addTorque(-100);
    }
  }
  float x = car.getX();
  float y = car.getY();
  if (0 < x && x < 200 && 600 < y && y < 800) {
    goal = true;
  }  
}

FBox createBox(float x, float y, float w, float h, 
  PImage img, boolean isStatic) {
  FBox b = new FBox(w, h);
  b.setPosition(x, y);
  b.attachImage(img);
  b.setStatic(isStatic);
  world.add(b);
  return b;
}
